<?php

declare(strict_types=1);

namespace Mirzaev\Feip\Methods;

use Mirzaev\Feip\Methods\MethodAbstract,
    Mirzaev\Feip\Error,
    Mirzaev\Feip\Params\Bar,
    Mirzaev\Feip\Params\Email,
    Mirzaev\Feip\Params\Users;

/**
 * Foo
 * 
 * @property string $bar bar
 * @property string $email Почта
 * @property array $users Пользователи
 * 
 * @method public function __construct(array $params) Сборщик
 * @method public filter(string $var, $params) Фильтрация входящих параметров
 * @method public function json() Возвращает json-строку собранную из объекта
 * @method private static function camelCase(string $text) Конвертация в camelCase (lower)
 * 
 * @see Mirzaev\Feip\Tests\Bar
 * 
 * @package Mirzaev\Feip\Methods\Bar
 * @author Арсен Мирзаев <red@hood.su>
 */
class BarMethod extends MethodAbstract
{
    use Bar, Email, Users;
}
