<?php

declare(strict_types=1);

namespace Mirzaev\Feip\Params;

use Mirzaev\Feip\Error,
    Mirzaev\Feip\Methods\MethodAbstract,
    Mirzaev\Feip\Params\FirstName,
    Mirzaev\Feip\Params\SecondName,
    Mirzaev\Feip\Params\Age;

/**
 * Параметр пользователей
 * 
 * @property array $users Пользователи
 * 
 * @package Mirzaev\Feip\Params
 * @author Арсен Мирзаев <red@hood.su>
 */
trait Users
{
    use FirstName, SecondName, Age;

    /**
     * Пользователи: параметр
     * 
     * @var array
     */
    protected array $users = [];

    /**
     * Before
     * 
     * Вызывается перед обработкой
     * 
     * @return void
     */
    public function usersBefore(): void
    {
        $this->ignore[] = 'first_name';
        $this->ignore[] = 'second_name';
        $this->ignore[] = 'age';
    }

    /**
     * After
     * 
     * Вызывается после обработки
     * 
     * @return void
     */
    public function usersAfter(): void
    {
    }
}
